<?php

	# 		Portugal Current Conditions
	# 		Namespace:		weatherPortugal
	#		Meteotemplate Block
	
	# 		v2.0 - May 29, 2017
	# 			- value based colors in table
	# 			- full compatibility with v14
	# 			- optimization
		
	// load theme
	$designTheme = json_decode(file_get_contents("../../css/theme.txt"),true);
	$theme = $designTheme['theme'];
	
	include("../../../config.php");
	include("../../../css/design.php");
	include("../../../scripts/functions.php");
	
	$languageRaw = file_get_contents($baseURL."lang/gb.php");
	$language['gb'] = json_decode($languageRaw,true);
	$languageRaw = file_get_contents($baseURL."lang/".$lang.".php");
	$language[$lang] = json_decode($languageRaw,true);
	
	if(!is_dir("cache")){
		mkdir("cache");
	}
	
	if(file_exists("cache/forecastPortugalCache.txt")){ 
		if (time()-filemtime("cache/forecastPortugalCache.txt") > 60 * 55) {
			unlink("cache/forecastPortugalCache.txt");
		}
	}
	if(file_exists("cache/forecastPortugalCache.txt")){
		$dataRaw = json_decode(file_get_contents("cache/forecastPortugalCache.txt"),true);
	}
	else { 
		$dataRaw = json_decode(file_get_contents("https://www.ipma.pt/resources.www/transf/obs-sup/observations.json"),true);
		file_put_contents("cache/forecastPortugalCache.txt",json_encode($dataRaw));
	}
	
	$stationsRaw = json_decode(file_get_contents("stations.txt"),true);
	
	for($i=0;$i<count($stationsRaw);$i++){
		$stations[$stationsRaw[$i]['properties']['idEstacao']]['name'] = $stationsRaw[$i]['properties']['localEstacao'];
	}
	
	foreach($dataRaw as $timestamp=>$stationsData){
		$dataFinal = array();
		foreach($stationsData as $stationID=>$values){
			if(is_array($values)){
				$dataFinal['name'] = $stations[$stationID]['name'];
				if(array_key_exists("temperatura",$values)){
					if($values['temperatura']>-50 && $values['temperatura']<70){
						$dataFinal['T'] = $values['temperatura'];
						$Ts[] = $values['temperatura'];
					}
				}
				if(array_key_exists("precAcumulada",$values)){
					if($values['precAcumulada']>=0 && $values['precAcumulada']<500){
						$dataFinal['R'] = $values['precAcumulada'];
						$Rs[] = $values['precAcumulada'];
					}
				}
				if(array_key_exists("intensidadeVentoKM",$values)){
					if($values['intensidadeVentoKM']>=0 && $values['intensidadeVentoKM']<500){
						$dataFinal['W'] = $values['intensidadeVentoKM'];
						$Ws[] = $values['intensidadeVentoKM'];
					}
				}
				if(array_key_exists("humidade",$values)){
					if($values['humidade']>=0 && $values['humidade']<=100){
						$dataFinal['H'] = $values['humidade'];
						$Hs[] = $values['humidade'];
					}
				}
				if(array_key_exists("pressao",$values)){
					if($values['pressao']>=950 && $values['pressao']<1070){
						$dataFinal['P'] = $values['pressao'];
						$Ps[] = $values['pressao'];
					}
				}
			}
			$data[strtotime($timestamp." Z")][] = $dataFinal;
			$dataFinal = array();
		}	
	}
	
	// sort data by timestamp
	krsort($data);
	
	// get the lates timestamp
	foreach($data as $dates=>$arrays){
		if(isset($currentDate)){}
		else{
			$currentDate = $dates;
		}
	}

	function sorter($a, $b) {
		return $a['name'] > $b['name'];
	}

	function fontColor($color){
		$tone = getColorHue($color,"rgb");
		return $tone=="light" ? "black" : "white";
	}
?>
	<style>
		.portugalCurrentIcon{
			opacity: 0.7;
			cursor: pointer;
			font-size: 2.4em;
			padding-bottom:10px;
			padding-left: 10px;
			padding-right: 10px;
		}
		.portugalCurrentIcon:hover{
			opacity: 1;
		}
		.sort{
			cursor: pointer;
			opacity: 0.8;
		}
		.sort:hover{
			opacity: 1;
		}		
	</style>
	<table style="width:90%;margin: 0 auto">
		<tr>
			<td style="text-align:left;width:25%">
				<img src="<?php echo $pageURL.$path?>imgs/<?php echo $flagIconShape?>/big/pt.png" style="width:100%;max-width:60px">
			</td>
			<td style="text-align:center">
				<h2><?php echo lang('current conditions','c')?></h2>
				<span style='font-weight:bold'><?php echo date($dateTimeFormat,$currentDate)?></span>
			</td>
			<td style="text-align:right;width:25%">	
				<img src="<?php echo $pageURL.$path?>imgs/climateImgs/outlines/pt.png" style="width:100%;max-width:50px">
			</td>			
		</tr>
	</table>
	<br>
	<div style="width:90%;text-align:center;margin:0 auto">
		<span class="mticon-temp portugalCurrentIcon" onclick="$('.portugalCurrentDiv').hide();$('#portugalCurrentT').slideDown()"></span>
		<span class="mticon-humidity portugalCurrentIcon" onclick="$('.portugalCurrentDiv').hide();$('#portugalCurrentH').slideDown()"></span>
		<span class="mticon-pressure portugalCurrentIcon" onclick="$('.portugalCurrentDiv').hide();$('#portugalCurrentP').slideDown()"></span>
		<span class="mticon-rain portugalCurrentIcon" onclick="$('.portugalCurrentDiv').hide();$('#portugalCurrentR').slideDown()"></span>
		<span class="mticon-wind portugalCurrentIcon" onclick="$('.portugalCurrentDiv').hide();$('#portugalCurrentW').slideDown()"></span>
	</div>
	<br>
	<div id="portugalCurrentT" class="portugalCurrentDiv">
		<table style="width:90%;margin:0 auto" class="table tablePortugal">
			<thead>
				<tr>
					<th>
					</th>
					<th style="text-align:center">
						°C<br><span class="fa fa-unsorted sort"></span>
					</th>
				</tr>
			</thead>
			<tbody>
				<?php 
					usort($data[$currentDate],'sorter');
					foreach($data[$currentDate] as $latestArray=>$values){
						if(count($values)>0){
				?>
							<tr>
								<td style="text-align:left">
									<?php 
										if(array_key_exists('name',$values)){
											echo $values['name'];
										}
									?>
								</td>
								<?php 
									if(array_key_exists('T',$values)){
										$colorT = fill($values['T'],array((min($Ts)-0.001),(max($Ts)+0.001)),array("#0040ff","#b30000"));
										$colorTFont = fontColor($colorT);
								?>
										<td style="text-align:right;background:<?php echo $colorT?>;color:<?php echo $colorTFont?>">
											<?php 
												echo number_format($values['T'],1,".","");
											?>
										</td>
								<?php 
									}
									else{
								?>
										<td></td>
								<?php 
									}
								?>						
							</tr>
				<?php
						}
					}
				?>
			</tbody>
		</table>
	</div>
	<div id="portugalCurrentH" class="portugalCurrentDiv">
		<table style="width:90%;margin:0 auto" class="table tablePortugal">
			<thead>
				<tr>
					<th>
					</th>
					<th style="text-align:center">
						%<br><span class="fa fa-unsorted sort"></span>
					</th>
				</tr>
			</thead>
			<tbody>
				<?php 
					foreach($data[$currentDate] as $latestArray=>$values){
						if(count($values)>0){
				?>
							<tr>
								<td style="text-align:left">
									<?php 
										if(array_key_exists('name',$values)){
											echo $values['name'];
										}
									?>
								</td>
								<?php 
									if(array_key_exists('H',$values)){
										$colorH = fill($values['H'],array((min($Hs)-0.001),(max($Hs)+0.001)),array("#f4b642","#088901"));
										$colorHFont = fontColor($colorH);
								?>
										<td style="text-align:right;background:<?php echo $colorH?>;color:<?php echo $colorHFont?>">
											<?php 
												echo number_format($values['H'],1,".","");
											?>
										</td>
								<?php 
									}
									else{
								?>
										<td></td>
								<?php 
									}
								?>						
							</tr>
				<?php
						}
					}
				?>
			</tbody>
		</table>
	</div>
	<div id="portugalCurrentP" class="portugalCurrentDiv">
		<table style="width:90%;margin:0 auto" class="table tablePortugal">
			<thead>
				<tr>
					<th>
					</th>
					<th style="text-align:center">
						hPa<br><span class="fa fa-unsorted sort"></span>
					</th>
				</tr>
			</thead>
			<tbody>
				<?php 
					foreach($data[$currentDate] as $latestArray=>$values){
						if(count($values)>0){
				?>
							<tr>
								<td style="text-align:left">
									<?php 
										if(array_key_exists('name',$values)){
											echo $values['name'];
										}
									?>
								</td>
								<?php 
									if(array_key_exists('P',$values)){
										$colorP = fill($values['P'],array((min($Ps)-0.001),(max($Ps)+0.001)),array("#d89000","#6d00c1"));
										$colorPFont = fontColor($colorP);
								?>
										<td style="text-align:right;background:<?php echo $colorP?>;color:<?php echo $colorPFont?>">
											<?php 
												echo number_format($values['P'],1,".","");
											?>
										</td>
								<?php 
									}
									else{
								?>
										<td></td>
								<?php 
									}
								?>						
							</tr>
				<?php
						}
					}
				?>
			</tbody>
		</table>
	</div>
	<div id="portugalCurrentR" class="portugalCurrentDiv">
		<table style="width:90%;margin:0 auto" class="table tablePortugal">
			<thead>
				<tr>
					<th>
					</th>
					<th style="text-align:center">
						mm<br><span class="fa fa-unsorted sort"></span>
					</th>
				</tr>
			</thead>
			<tbody>
				<?php 
					foreach($data[$currentDate] as $latestArray=>$values){
						if(count($values)>0){
				?>
							<tr>
								<td style="text-align:left">
									<?php 
										if(array_key_exists('name',$values)){
											echo $values['name'];
										}
									?>
								</td>
								<?php 
									if(array_key_exists('R',$values)){
										if($values['R']==0){
											$colorR = "rgb(255,255,255)";
										}
										else{
											$colorR = fill($values['R'],array(0,max($Rs)+0.0001),array("#ccebff","#0c31ad"));
										}
										$colorRFont = fontColor($colorR);
								?>
										<td style="text-align:right;background:<?php echo $colorR?>;color:<?php echo $colorRFont?>">
											<?php 
												echo number_format($values['R'],1,".","");
											?>
										</td>
								<?php 
									}
									else{
								?>
										<td></td>
								<?php 
									}
								?>						
							</tr>
				<?php
						}
					}
				?>
			</tbody>
		</table>
	</div>
	<div id="portugalCurrentW" class="portugalCurrentDiv">
		<table style="width:90%;margin:0 auto" class="table tablePortugal">
			<thead>
				<tr>
					<th>
					</th>
					<th style="text-align:center">
						km/h<br><span class="fa fa-unsorted sort"></span>
					</th>
				</tr>
			</thead>
			<tbody>
				<?php 
					foreach($data[$currentDate] as $latestArray=>$values){
						if(count($values)>0){
				?>
							<tr>
								<td style="text-align:left">
									<?php 
										if(array_key_exists('name',$values)){
											echo $values['name'];
										}
									?>
								</td>
								<?php 
									if(array_key_exists('W',$values)){
										$colorW = fill($values['W'],array((min($Ws)-0.001),(max($Ws)+0.001)),array("#8e8e8e","#91008e"));
										$colorWFont = fontColor($colorW);
								?>
										<td style="text-align:right;background:<?php echo $colorW?>;color:<?php echo $colorWFont?>">
											<?php 
												echo number_format($values['W'],1,".","");
											?>
										</td>
								<?php 
									}
									else{
								?>
										<td></td>
								<?php 
									}
								?>						
							</tr>
				<?php
						}
					}
				?>
			</tbody>
		</table>
	</div>
	<div style="width:90%;margin:0 auto;font-size:0.8em;font-variant:small-caps">
		<span class="more" onclick="$('.portugalCurrentDiv').slideUp();"><?php echo lang('close','c')?></span>
	</div>
	</div>
	<div style="width:90%;margin:0 auto;font-size:0.8em;font-variant:small-caps">
		<?php echo lang('data source','c')?>: Instituto Português do Mar e da Atmosfera 
	</div>
	<script type="text/javascript" src="<?php echo $pageURL.$path?>scripts/jquery.tablesorter.js"></script>
	<script>
		$(".portugalCurrentDiv").hide();
		$(".tablePortugal").tablesorter();
	</script>
	